using System;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

namespace Redeyes
{
public class DiviningLipsAndHands : MVRScript
{

    protected struct PersonInfo
    {
        public Atom PersonAtom;
        public bool IsFemale;
        public Component atomRHand;
        public Component atomLHand;
        public Component atomMouth;
        public Component penisMidControl;
        public DAZMorph Right_Fingers_Grasp;
        //public DAZMorph Right_Thumb_Fist;
        //public DAZMorph Right_Thumb_In_Out;
        public DAZMorph Right_Thumb_Bend;
        public DAZMorph Right_Thumb_Grasp;

        public DAZMorph Left_Fingers_Grasp;
        //public DAZMorph Left_Thumb_Fist;
        //public DAZMorph Left_Thumb_In_Out;
        public DAZMorph Left_Thumb_Bend;
        public DAZMorph Left_Thumb_Grasp;

        public DAZMorph Mouth_Wide_Open;
        public DAZMorph Lips_Close;
        public DAZMorph BJ_DX_Mouth_Open_Shape;
        public DAZMorph BJ_DX_Mouth_Suck_Shape_1;
        public DAZMorph BJ_DX_Mouth_Corner_Depth_L;
        public DAZMorph BJ_DX_Mouth_Corner_Depth_R;
    }

    protected List<PersonInfo> ListOfPersonAtoms = new List<PersonInfo>();

    protected Component potentialRHandTarget;
    protected Component potentialRHandTIPTarget;
    protected Component potentialLHandTarget;
    protected Component potentialLHandTIPTarget;
    protected Component potentialMouthTarget;
    protected float potentialRHandTargetDistance;
    protected float potentialABSRHandTargetDistance;
    protected float potentialLHandTargetDistance;
    protected float potentialABSLHandTargetDistance;
    protected float potentialMouthTargetDistance;

    protected bool targetWithinDistance;

    protected string _targetType;

    protected float _targetDistance;
    protected Atom _targetAtom = null;

    protected float _targetTipToBaseDistance;
    protected float _tmpPotentialDistance;

    protected float hand_grasp_a;
    protected float hand_grasp_b;
    protected float thumb_grasp_a;
    protected float thumb_grasp_b;
    protected float thumb_bend_a;
    protected float thumb_bend_b;
    protected float thumb_bend_start;
    protected float thumb_bend_end;
    protected float hand_grasp_start;
    protected float hand_grasp_end;

    protected float mouth_open_a;
    protected float mouth_open_b;
    protected float mouth_suck_a;
    protected float mouth_suck_b;
    protected float mouth_open_start;
    protected float mouth_open_end;

    protected float hand_grasp_amount;
    protected float thumb_grasp_amount;
    protected float thumb_bend_amount;
    protected float mouth_amount;
    protected float tmp_object_offset;
    protected float tmp_lHand_object_offset;
    protected float tmp_mouth_object_offset;


    protected JSONStorableBool _handGraspEnabledJSON = new JSONStorableBool("Hand Grasp Enable", true);
    protected JSONStorableBool _thumbBendEnabledJSON = new JSONStorableBool("Thumb Bend Experimental Enable", true);
    protected JSONStorableBool _lipsSuckEnabledJSON = new JSONStorableBool("Lips suck Enable", true);
    protected JSONStorableFloat _morpheChangeRangeJSON = new JSONStorableFloat("Morphe Range of Change", 0.04f, 0f, 0.1f, false);

    protected JSONStorableFloat _handGraspRangeJSON = new JSONStorableFloat("Hand Grasp Range", 0.15f, 0.05f, 1.0f, false);
    protected JSONStorableFloat _thumbGraspRangeJSON = new JSONStorableFloat("Thumb Grasp Range", 0.15f, 0.05f, 1.0f, false);
    protected JSONStorableFloat _thumbBendRangeJSON = new JSONStorableFloat("Thumb Bend Range", 0.07f, 0.0f, 1.0f, false);

    protected JSONStorableFloat DildoOffsetJSON = new JSONStorableFloat("Dildo Offset", -0.04f, -0.5f, 0.5f, false);

    protected JSONStorableFloat _hand_grasp_amountJSON = new JSONStorableFloat("Hand Grasp Amount", 1.0f, 0.00f, 1.0f, false);
    protected JSONStorableFloat _Thumb_Fist_amountJSON = new JSONStorableFloat("Thumb Fist Amount", 0.727f, 0.00f, 1.0f, false);
    protected JSONStorableFloat _Thumb_In_Out_amountJSON = new JSONStorableFloat("Thumb In Out Amount", 0.37f, 0.00f, 1.0f, false);
    protected JSONStorableFloat _thumb_Bend_amountJSON = new JSONStorableFloat("Thumb Bend Amount", 0.45f, 0.00f, 1.0f, false);

    protected JSONStorableFloat _mouthOpenRangeJSON = new JSONStorableFloat("Mouth Open Range", 0.23f, 0.05f, 1.0f, false);
    protected JSONStorableFloat _suckRangeJSON = new JSONStorableFloat("Start Suck Range", 0.18f, 0.00f, 1.0f, false);
    protected JSONStorableFloat  Mouth_Open_Wide_Amount_JSON = new JSONStorableFloat("Mouth Open Wide amount", 0.7f, 0.0f, 1.0f, false);
    protected JSONStorableFloat  BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON = new JSONStorableFloat("BJ suck amount", 0.7f, 0.0f, 1.0f, false);
    protected JSONStorableFloat  lips_close_amountJSON = new JSONStorableFloat("Lips closed amount", 0.2f, 0.0f, 1.0f, false);

    protected JSONStorableFloat _minTargetDistanceJSON = new JSONStorableFloat("Min Target Distance [cm]", 25f, 0f, 100f, false);

    protected JSONStorableFloat _mouthOffsetXJSON = new JSONStorableFloat("Mouth Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _mouthOffsetYJSON = new JSONStorableFloat("Mouth Offset Y [cm]", -1.5f, -10f, 10f, false);
    protected JSONStorableFloat _mouthOffsetZJSON = new JSONStorableFloat("Mouth Offset Z [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetXJSON = new JSONStorableFloat("Hand Offset X [cm]", 7f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetYJSON = new JSONStorableFloat("Hand Offset Y [cm]", -1.6f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetZJSON = new JSONStorableFloat("Hand Offset Z [cm]", 2f, -10f, 10f, false);

    protected JSONStorable js;
    protected DAZCharacterSelector dcs;
    protected GenerateDAZMorphsControlUI morphUI;

    protected Vector3 yzDirection;
    protected Vector3 xToY;
    protected Vector3 projection;

    public static bool IsFemale(Atom person)
    {
        bool retVal = true;
        DAZCharacter character = person.GetComponentInChildren<DAZCharacter>();
        if (character != null)
        {
            retVal = !character.isMale;
        }
        return retVal;
    }

    protected void syncPersonAtoms()
    {
            //SuperController.LogMessage("syncPersonAtoms");
            ListOfPersonAtoms = new List<PersonInfo>(); // empty list
            List<Atom> tmp_ListOfPersonAtoms;
            tmp_ListOfPersonAtoms = SuperController.singleton.GetAtoms().Where(atom => atom.type == "Person" || atom.type == "Dildo").ToList();
            ListOfPersonAtoms.Clear();
            foreach (Atom personAtom in tmp_ListOfPersonAtoms)
            {
                PersonInfo personInfo;
                personInfo.PersonAtom = personAtom;
                if (personAtom.type == "Person")
                {
                    personInfo.IsFemale = IsFemale(personAtom);
                    personInfo.atomRHand = personAtom.rigidbodies.First(rb => rb.name == "rHand");
                    personInfo.atomLHand = personAtom.rigidbodies.First(rb => rb.name == "lHand");
                    personInfo.atomMouth = personAtom.rigidbodies.First(rb => rb.name == "LipTrigger");
                    personInfo.penisMidControl = personAtom.freeControllers.First(fc => fc.name == "penisMidControl");

                    js = personAtom.GetStorableByID("geometry");
                    dcs = js as DAZCharacterSelector;
                    morphUI = dcs.morphsControlUI;

                    //personInfo.Right_Fingers_Grasp = morphUI.GetMorphByDisplayName("Right Fingers Grasp");
                    personInfo.Right_Fingers_Grasp = morphUI.GetMorphByDisplayName("Penis_Grip_R");
                    //personInfo.Right_Thumb_Fist = morphUI.GetMorphByDisplayName("Right Thumb Fist");
                    //personInfo.Right_Thumb_In_Out  = morphUI.GetMorphByDisplayName("Right Thumb In-Out");
                    personInfo.Right_Thumb_Bend = morphUI.GetMorphByDisplayName("Right Thumb Bend");
                    personInfo.Right_Thumb_Grasp = morphUI.GetMorphByDisplayName("Right Thumb Grasp");

                    //personInfo.Left_Fingers_Grasp = morphUI.GetMorphByDisplayName("Left Fingers Grasp");
                    personInfo.Left_Fingers_Grasp = morphUI.GetMorphByDisplayName("Penis Grip L");
                    //personInfo.Left_Thumb_Fist = morphUI.GetMorphByDisplayName("Left Thumb Fist");
                    //personInfo.Left_Thumb_In_Out  = morphUI.GetMorphByDisplayName("Left Thumb In-Out");
                    personInfo.Left_Thumb_Bend  = morphUI.GetMorphByDisplayName("Left Thumb Bend");
                    personInfo.Left_Thumb_Grasp = morphUI.GetMorphByDisplayName("Left Thumb Grasp");

                    personInfo.Mouth_Wide_Open  = morphUI.GetMorphByDisplayName("Mouth Open Wide");
                    personInfo.BJ_DX_Mouth_Open_Shape  = morphUI.GetMorphByDisplayName("[BJ DX] Mouth Open Shape");
                    personInfo.BJ_DX_Mouth_Suck_Shape_1  = morphUI.GetMorphByDisplayName("[BJ DX] Mouth Suck Shape 1");
                    personInfo.BJ_DX_Mouth_Corner_Depth_L  = morphUI.GetMorphByDisplayName("[BJ DX] Mouth Corner Depth L");
                    personInfo.BJ_DX_Mouth_Corner_Depth_R  = morphUI.GetMorphByDisplayName("[BJ DX] Mouth Corner Depth R");
                    if (personInfo.IsFemale)
                    {
                        personInfo.Lips_Close  = morphUI.GetMorphByDisplayName("Lips Close");
                    }
                    else
                    {
                        personInfo.Lips_Close  = null;
                    }
                    if (personInfo.BJ_DX_Mouth_Open_Shape == null || personInfo.BJ_DX_Mouth_Suck_Shape_1 == null || personInfo.Right_Fingers_Grasp == null || personInfo.Left_Fingers_Grasp == null)
                    {
                        SuperController.LogError("Missing 1 or more of the following morphes -> BJ DX] Mouth Open Shape and BJ DX] Mouth Suck Shape 1\nPLEASE DOWNLOAD ALL DEPENDENCIES");
                        DestroyImmediate(this);
                        return;
                    }
                }
                else
                {
                    personInfo.IsFemale = false;
                    personInfo.atomRHand = null;
                    personInfo.atomLHand = null;
                    personInfo.atomMouth = null;
                    personInfo.penisMidControl = null;

                    personInfo.Right_Fingers_Grasp = null;
                    //personInfo.Right_Thumb_Fist = null;
                    //personInfo.Right_Thumb_In_Out = null;
                    personInfo.Right_Thumb_Bend = null;
                    personInfo.Right_Thumb_Grasp = null;

                    personInfo.Left_Fingers_Grasp = null;
                    //personInfo.Left_Thumb_Fist = null;
                    //personInfo.Left_Thumb_In_Out  = null;
                    personInfo.Left_Thumb_Bend  = null;
                    personInfo.Left_Thumb_Grasp = null;

                    personInfo.Mouth_Wide_Open  = null;
                    personInfo.BJ_DX_Mouth_Open_Shape  = null;
                    personInfo.BJ_DX_Mouth_Suck_Shape_1  = null;
                    personInfo.BJ_DX_Mouth_Corner_Depth_L  = null;
                    personInfo.BJ_DX_Mouth_Corner_Depth_R  = null;
                    personInfo.Lips_Close  = null;
                }
                ListOfPersonAtoms.Add(personInfo);
            }
    }

    public override void Init()
    {
        UIDynamicTextField text = null;
        try
        {
            if (containingAtom.type != "CoreControl" && containingAtom.type != "SessionPluginManager")
            {
                SuperController.LogError($"Please load DiviningLipsAndHands as a Session or Scene Plugin, not with a '{containingAtom.type}' atom.");
                DestroyImmediate(this);
                return;
            }

            SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
            SuperController.singleton.onAtomUIDsChangedHandlers += OnAtomUIDsChanged;
            SuperController.LogMessage("Starting DiviningLipsAndHands");
            //PENIS CONTROLS
            _handGraspEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_handGraspEnabledJSON);
            CreateToggle(_handGraspEnabledJSON, false);

            _thumbBendEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_thumbBendEnabledJSON);
            CreateToggle(_thumbBendEnabledJSON, false);

            _lipsSuckEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_lipsSuckEnabledJSON);
            CreateToggle(_lipsSuckEnabledJSON, true);

            _handGraspRangeJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handGraspRangeJSON);
            CreateSlider(_handGraspRangeJSON, false);

            _thumbGraspRangeJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_thumbGraspRangeJSON);
            CreateSlider(_thumbGraspRangeJSON, false);

            _thumbBendRangeJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_thumbBendRangeJSON);
            CreateSlider(_thumbBendRangeJSON, false);

            _hand_grasp_amountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_hand_grasp_amountJSON);
            CreateSlider(_hand_grasp_amountJSON, false);

            _Thumb_Fist_amountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_Thumb_Fist_amountJSON);
            CreateSlider(_Thumb_Fist_amountJSON, false);

            _Thumb_In_Out_amountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_Thumb_In_Out_amountJSON);
            CreateSlider(_Thumb_In_Out_amountJSON, false);

            _thumb_Bend_amountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_thumb_Bend_amountJSON);
            CreateSlider(_thumb_Bend_amountJSON, false);
            _mouthOpenRangeJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOpenRangeJSON);
            CreateSlider(_mouthOpenRangeJSON, true);

            _suckRangeJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_suckRangeJSON);
            CreateSlider(_suckRangeJSON, true);

            Mouth_Open_Wide_Amount_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(Mouth_Open_Wide_Amount_JSON);
            CreateSlider(Mouth_Open_Wide_Amount_JSON, true);

            BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON);
            CreateSlider(BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON, true);

            lips_close_amountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(lips_close_amountJSON);
            CreateSlider(lips_close_amountJSON, true);

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            DildoOffsetJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(DildoOffsetJSON);
            CreateSlider(DildoOffsetJSON, false);

            _morpheChangeRangeJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_morpheChangeRangeJSON);
            CreateSlider(_morpheChangeRangeJSON, false);

            _minTargetDistanceJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_minTargetDistanceJSON);
            CreateSlider(_minTargetDistanceJSON, false);

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _handOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetXJSON);
            CreateSlider(_handOffsetXJSON, false);
            _handOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetYJSON);
            CreateSlider(_handOffsetYJSON, false);
            _handOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetZJSON);
            CreateSlider(_handOffsetZJSON, false);

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _mouthOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetXJSON);
            CreateSlider(_mouthOffsetXJSON, false);
            _mouthOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetYJSON);
            CreateSlider(_mouthOffsetYJSON, false);
            _mouthOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetZJSON);
            CreateSlider(_mouthOffsetZJSON, false);


            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            syncPersonAtoms();
            //SuperController.LogMessage($"{nameof(DiviningLipsAndHands)} initialized");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningLipsAndHands)}.{nameof(Init)}: {e}");
        }
    }

        private void OnSceneLoaded()
        {
            try {
                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnSceneLoaded: " + e);
            }
        }

        private void OnAtomUIDsChanged(List<string> atomUIDs)
        {
            try {
                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnAtomUIDsChanged: " + e);
            }
        }


    public void OnEnable()
    {
        try
        {
            syncPersonAtoms();
            //SuperController.LogMessage($"{nameof(DiviningLipsAndHands)} enabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningLipsAndHands)}.{nameof(OnEnable)}: {e}");
        }
    }

    public void cleanup()
    {
        foreach (PersonInfo personInfo in ListOfPersonAtoms)
        {
            if (personInfo.PersonAtom.type == "Person")
            {
                personInfo.Right_Fingers_Grasp.morphValue = 0f;
                //personInfo.Right_Thumb_Fist.morphValue = 0f;
                //personInfo.Right_Thumb_In_Out.morphValue = 0f;
                personInfo.Right_Thumb_Bend.morphValue = 0f;
                personInfo.Right_Thumb_Grasp.morphValue = 0f;

                personInfo.Left_Fingers_Grasp.morphValue = 0f;
                //personInfo.Left_Thumb_Fist.morphValue = 0f;
                //personInfo.Left_Thumb_In_Out.morphValue = 0f;
                personInfo.Left_Thumb_Bend.morphValue = 0f;
                personInfo.Left_Thumb_Grasp.morphValue = 0f;

                personInfo.Mouth_Wide_Open.morphValue = 0f;
                personInfo.BJ_DX_Mouth_Open_Shape.morphValue = 0f;
                personInfo.BJ_DX_Mouth_Suck_Shape_1.morphValue = 0f;
                personInfo.BJ_DX_Mouth_Corner_Depth_L.morphValue = 0f;
                personInfo.BJ_DX_Mouth_Corner_Depth_R.morphValue = 0f;
                if (personInfo.IsFemale)
                {
                    personInfo.Lips_Close.morphValue = 0f;
                }
            }
        }
    }

    public void OnDisable()
    {
        try
        {
            cleanup();
            //SuperController.LogMessage($"{nameof(DiviningLipsAndHands)} disabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningLipsAndHands)}.{nameof(OnDisable)}: {e}");
        }
    }

    public void OnDestroy()
    {
        try
        {
            cleanup();
            //SuperController.LogMessage($"{nameof(DiviningLipsAndHands)} destroyed");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningLipsAndHands)}.{nameof(OnDestroy)}: {e}");
        }
    }


    public Vector3 GetOffset(string targetType)
    {
        Vector3 offset = new Vector3(0f, 0f, 0f);
        if (targetType == "rHand")
        {
            offset =  new Vector3(_handOffsetXJSON.val, _handOffsetYJSON.val, _handOffsetZJSON.val);
        }
        else if (targetType == "lHand")
        {
            // swap x axis for left hand
            offset =  new Vector3(-_handOffsetXJSON.val, _handOffsetYJSON.val, _handOffsetZJSON.val);
        }
        else if (targetType == "Mouth")
        {
            offset = new Vector3( _mouthOffsetXJSON.val, _mouthOffsetYJSON.val, _mouthOffsetZJSON.val);
        }

        return offset * 0.01f; // cm to m
    }

    public float DistanceNearsetBetweenLine(Vector3 target, Vector3 Postion1, Vector3 Postion2)
    {
        //ensure dildo has a direction
        Postion1 += new Vector3(0f,0f,0.0001f);
        yzDirection = (Postion2 - Postion1).normalized; // the direction of the line between Y and Z
        xToY = Postion1 - target; // vector from X to Y
        projection = Vector3.ProjectOnPlane(xToY, yzDirection); // projection of xToY onto the plane perpendicular to yzDirection
        return projection.magnitude; // the distance between X and the nearest point on the line
    }

    // FixedUpdate is called with each physics simulation frame by Unity
    void FixedUpdate()
    {
        try
        {
            foreach (PersonInfo personInfo in ListOfPersonAtoms)
            {
                if (personInfo.PersonAtom.type == "Person")
                {
                    potentialRHandTargetDistance = _minTargetDistanceJSON.val * 0.01f;
                    potentialABSRHandTargetDistance = _minTargetDistanceJSON.val * 0.01f;
                    potentialLHandTargetDistance = _minTargetDistanceJSON.val * 0.01f;
                    potentialABSLHandTargetDistance = _minTargetDistanceJSON.val * 0.01f;
                    potentialMouthTargetDistance = _minTargetDistanceJSON.val * 0.01f;
                    foreach (PersonInfo potentialTarget in ListOfPersonAtoms)
                    {
                        if ((potentialTarget.PersonAtom.type == "Person" && !potentialTarget.IsFemale ) || potentialTarget.PersonAtom.type == "Dildo")
                        //if (potentialTarget.PersonAtom.type == "Person" && !potentialTarget.IsFemale)
                        {
                            if(potentialTarget.PersonAtom.type == "Dildo")
                            {
                                potentialRHandTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "control");
                                potentialRHandTIPTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "control");
                                potentialLHandTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "control");
                                potentialLHandTIPTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "control");
                                potentialMouthTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "control");
                            }
                            else
                            {
                                potentialRHandTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "penisMidControl");
                                potentialRHandTIPTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "penisTipControl");
                                potentialLHandTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "penisMidControl");
                                potentialLHandTIPTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "penisTipControl");
                                potentialMouthTarget = potentialTarget.PersonAtom.freeControllers.First(fc => fc.name == "penisMidControl");
                            }

                            if (_handGraspEnabledJSON.val)
                            {
                                //RIGHT HAND
                                //_tmpPotentialDistance=(potentialRHandTarget.transform.position - personInfo.atomRHand.transform.TransformPoint(GetOffset("rHand"))).magnitude;
                                _tmpPotentialDistance = DistanceNearsetBetweenLine(personInfo.atomRHand.transform.TransformPoint(GetOffset("rHand")), potentialRHandTarget.transform.position, potentialRHandTIPTarget.transform.position);
                                if (_tmpPotentialDistance < potentialRHandTargetDistance && (potentialRHandTarget.transform.position - personInfo.atomRHand.transform.TransformPoint(GetOffset("rHand"))).magnitude < (_minTargetDistanceJSON.val * 0.01f))
                                {
                                    tmp_object_offset=(potentialTarget.PersonAtom.type == "Dildo" ? DildoOffsetJSON.val : 0f);
                                    potentialRHandTargetDistance = _tmpPotentialDistance + tmp_object_offset;
                                }

                                //LEFT HAND
                                _tmpPotentialDistance = DistanceNearsetBetweenLine(personInfo.atomLHand.transform.TransformPoint(GetOffset("lHand")), potentialLHandTarget.transform.position, potentialLHandTIPTarget.transform.position);
                                if (_tmpPotentialDistance < potentialLHandTargetDistance && (potentialLHandTarget.transform.position - personInfo.atomLHand.transform.TransformPoint(GetOffset("lHand"))).magnitude < (_minTargetDistanceJSON.val * 0.01f))
                                {
                                    tmp_object_offset=(potentialTarget.PersonAtom.type == "Dildo" ? DildoOffsetJSON.val : 0f);
                                    potentialLHandTargetDistance = _tmpPotentialDistance + tmp_object_offset;
                                }
                            }

                            if (_thumbBendEnabledJSON.val)
                            {
                                //RIGHT HAND
                                _tmpPotentialDistance = DistanceNearsetBetweenLine(personInfo.atomRHand.transform.TransformPoint(GetOffset("rHand")), potentialRHandTarget.transform.position, potentialRHandTIPTarget.transform.position);
                                if (_tmpPotentialDistance < potentialABSRHandTargetDistance && (potentialRHandTarget.transform.position - personInfo.atomRHand.transform.TransformPoint(GetOffset("rHand"))).magnitude < (_minTargetDistanceJSON.val * 0.01f))
                                {
                                    tmp_object_offset=(potentialTarget.PersonAtom.type == "Dildo" ? DildoOffsetJSON.val : 0f);
                                    potentialABSRHandTargetDistance = _tmpPotentialDistance + tmp_object_offset;
                                }
                                //LEFT HAND
                                _tmpPotentialDistance = DistanceNearsetBetweenLine(personInfo.atomLHand.transform.TransformPoint(GetOffset("lHand")), potentialLHandTarget.transform.position, potentialLHandTIPTarget.transform.position);
                                if (_tmpPotentialDistance < potentialABSLHandTargetDistance && (potentialLHandTarget.transform.position - personInfo.atomLHand.transform.TransformPoint(GetOffset("lHand"))).magnitude < (_minTargetDistanceJSON.val * 0.01f))
                                {
                                    tmp_object_offset=(potentialTarget.PersonAtom.type == "Dildo" ? DildoOffsetJSON.val : 0f);
                                    potentialABSLHandTargetDistance = _tmpPotentialDistance + tmp_object_offset;
                                }
                            }

                            if (_lipsSuckEnabledJSON.val)
                            {
                                //MOUTH
                                _tmpPotentialDistance=(potentialMouthTarget.transform.position - personInfo.atomMouth.transform.TransformPoint(GetOffset("Mouth"))).magnitude;
                                if (_tmpPotentialDistance < potentialMouthTargetDistance)
                                {
                                    tmp_object_offset=(potentialTarget.PersonAtom.type == "Dildo" ? DildoOffsetJSON.val : 0f);
                                    potentialMouthTargetDistance = _tmpPotentialDistance + tmp_object_offset;
                                }
                            }
                        }
                    }
                    js = personInfo.PersonAtom.GetStorableByID("geometry");
                    dcs = js as DAZCharacterSelector;
                    morphUI = dcs.morphsControlUI;

                    hand_grasp_a = _handGraspRangeJSON.val - _morpheChangeRangeJSON.val;
                    hand_grasp_b = _handGraspRangeJSON.val + _morpheChangeRangeJSON.val;
                    thumb_grasp_a = _thumbGraspRangeJSON.val - _morpheChangeRangeJSON.val;
                    thumb_grasp_b = _thumbGraspRangeJSON.val + _morpheChangeRangeJSON.val;
                    thumb_bend_a = _thumbBendRangeJSON.val - (_morpheChangeRangeJSON.val);
                    thumb_bend_b = _thumbBendRangeJSON.val + (_morpheChangeRangeJSON.val);
                    hand_grasp_start=0f;
                    hand_grasp_end=-1.0f;
                    thumb_bend_start=-1f;
                    thumb_bend_end=0f;
                    //Mathf.Abs(x - y);
                    //amount = (target_Distance-A)/(B-A) * (D-C) + C;
                    hand_grasp_start=0f;
                    hand_grasp_end=-1.0f;
                    mouth_open_a = _mouthOpenRangeJSON.val - _morpheChangeRangeJSON.val;
                    mouth_open_b = _mouthOpenRangeJSON.val + _morpheChangeRangeJSON.val;
                    mouth_suck_a = _suckRangeJSON.val - _morpheChangeRangeJSON.val;// - 0.1f;
                    mouth_suck_b = _suckRangeJSON.val + _morpheChangeRangeJSON.val;// + 0.1f;
                    mouth_open_start=0f;
                    mouth_open_end=-(BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val > Mouth_Open_Wide_Amount_JSON.val ? BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val : Mouth_Open_Wide_Amount_JSON.val);//BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val;

                    if (_handGraspEnabledJSON.val)
                    {
                        if (potentialRHandTargetDistance < (_minTargetDistanceJSON.val * 0.01f))
                        {
                            hand_grasp_amount = (potentialRHandTargetDistance-hand_grasp_a)/(hand_grasp_b-hand_grasp_a) * (hand_grasp_end-hand_grasp_start) + hand_grasp_start;
                            thumb_grasp_amount = (potentialRHandTargetDistance-thumb_grasp_a)/(thumb_grasp_b-thumb_grasp_a) * (hand_grasp_end-hand_grasp_start) + hand_grasp_start;
                            personInfo.Right_Fingers_Grasp.morphValue =  Mathf.Clamp(hand_grasp_amount, 0f, _hand_grasp_amountJSON.val);
                            //personInfo.Right_Thumb_Fist.morphValue =  Mathf.Clamp(thumb_grasp_amount, 0f, _Thumb_Fist_amountJSON.val);
                            //personInfo.Right_Thumb_In_Out.morphValue =  Mathf.Clamp(thumb_grasp_amount, 0f, _Thumb_In_Out_amountJSON.val);
                        }

                        if (potentialLHandTargetDistance < (_minTargetDistanceJSON.val * 0.01f))
                        {
                            hand_grasp_amount = (potentialLHandTargetDistance-hand_grasp_a)/(hand_grasp_b-hand_grasp_a) * (hand_grasp_end-hand_grasp_start) + hand_grasp_start;
                            thumb_grasp_amount = (potentialLHandTargetDistance-thumb_grasp_a)/(thumb_grasp_b-thumb_grasp_a) * (hand_grasp_end-hand_grasp_start) + hand_grasp_start;
                            personInfo.Left_Fingers_Grasp.morphValue =  Mathf.Clamp(hand_grasp_amount, 0f, _hand_grasp_amountJSON.val);
                            //personInfo.Left_Thumb_Fist.morphValue =  Mathf.Clamp(thumb_grasp_amount, 0f, _Thumb_Fist_amountJSON.val);
                            //personInfo.Left_Thumb_In_Out.morphValue =  Mathf.Clamp(thumb_grasp_amount, 0f, _Thumb_In_Out_amountJSON.val);
                        }
                    }

                    if (_thumbBendEnabledJSON.val)
                    {
                        if (potentialABSRHandTargetDistance < (_minTargetDistanceJSON.val * 0.01f))
                        {
                            potentialABSRHandTargetDistance = Mathf.Abs(potentialABSRHandTargetDistance-_thumbBendRangeJSON.val) * 4.0f;
                            thumb_bend_amount = (potentialABSRHandTargetDistance-thumb_bend_a)/(thumb_bend_b-thumb_bend_a) * (thumb_bend_end-thumb_bend_start) + thumb_bend_start;
                            personInfo.Right_Thumb_Bend.morphValue =  Mathf.Clamp(thumb_bend_amount, -_thumb_Bend_amountJSON.val, 0f);
                            personInfo.Right_Thumb_Grasp.morphValue =  Mathf.Clamp(thumb_bend_amount, -_thumb_Bend_amountJSON.val, 0f);
                            //SuperController.LogMessage("thumb_bend_amount " + thumb_bend_amount + " potentialABSRHandTargetDistance " + potentialABSRHandTargetDistance);
                        }
                        if (potentialABSLHandTargetDistance < (_minTargetDistanceJSON.val * 0.01f))
                        {
                            potentialABSLHandTargetDistance = Mathf.Abs(potentialABSLHandTargetDistance-_thumbBendRangeJSON.val) * 4.0f;
                            thumb_bend_amount = (potentialABSLHandTargetDistance-thumb_bend_a)/(thumb_bend_b-thumb_bend_a) * (thumb_bend_end-thumb_bend_start) + thumb_bend_start;
                            personInfo.Left_Thumb_Bend.morphValue =  Mathf.Clamp(thumb_bend_amount, -_thumb_Bend_amountJSON.val, 0f);
                            personInfo.Left_Thumb_Grasp.morphValue =  Mathf.Clamp(thumb_bend_amount, -_thumb_Bend_amountJSON.val, 0f);
                            //SuperController.LogMessage("thumb_bend_amount " + thumb_bend_amount + " potentialABSLHandTargetDistance " + potentialABSLHandTargetDistance);
                        }
                    }

                    if (_lipsSuckEnabledJSON.val)
                    {
                        if (potentialMouthTargetDistance < (_minTargetDistanceJSON.val * 0.01f))
                        {
                            hand_grasp_amount = (potentialMouthTargetDistance-mouth_open_a)/(mouth_open_b-mouth_open_a) * (mouth_open_end-mouth_open_start) + mouth_open_start;
                            mouth_amount = (potentialMouthTargetDistance - mouth_suck_a)/(mouth_suck_b-mouth_suck_a) * (mouth_open_end-mouth_open_start) + mouth_open_start;
                            personInfo.Mouth_Wide_Open.morphValue =  Mathf.Clamp(hand_grasp_amount, 0f, Mouth_Open_Wide_Amount_JSON.val);
                            personInfo.BJ_DX_Mouth_Open_Shape.morphValue =  Mathf.Clamp(mouth_amount, 0f, BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val);
                            personInfo.BJ_DX_Mouth_Suck_Shape_1.morphValue =  Mathf.Clamp(mouth_amount, 0f, BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val);
                            personInfo.BJ_DX_Mouth_Corner_Depth_L.morphValue =  Mathf.Clamp(mouth_amount, 0f, BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val);
                            personInfo.BJ_DX_Mouth_Corner_Depth_R.morphValue =  Mathf.Clamp(mouth_amount, 0f, BJ_DX_Mouth_Suck_Shape_1_AMOUNT_JSON.val);
                            if (personInfo.IsFemale)
                            {
                                personInfo.Lips_Close.morphValue =  Mathf.Clamp(mouth_amount, 0f, lips_close_amountJSON.val);
                            }
                        }
                    }
                }
            }
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningLipsAndHands)}.{nameof(FixedUpdate)}: {e}");
        }
    }
}

} // namespace ToumeiHitsuji end
